
public class SearchTree {

    int val;
    boolean empty;
    SearchTree left;
    SearchTree right;

    SearchTree() {
        empty = true;
        left = null;
        right = null;
    }

    void insert(int v) {
        if (empty) {
            val = v;
            empty = false;
        } else {
            if (v < val) {
                if (left == null) {
                    left = new SearchTree();
                }

                left.insert(v);
            } else if (v > val) {

                if (right == null) {
                    right = new SearchTree();
                }

                right.insert(v);
            }
        }
    }

    int search(int v) {
        if (empty) {
            return 0;
        }
        if (v == val) {
            return 1;
        }

        int res = 0;

        if (v < val) {
            if (left != null) {
                res = left.search(v);
            }
        } else {
            if (right != null) {
                res = right.search(v);
            }
        }

        if (res > 0) {
            return res + 1;
        }

        return 0;
    }

    int min() {
        if (empty) {
            return -1;
        }

        int res = -1;
        if (left != null) {
            res = left.min();
        }

        if (res >= 0) {
            return res;
        }

        return val;
    }

    int max() {
        if (empty) {
            return -1;
        }

        int res = -1;
        if (right != null) {
            res = right.max();
        }

        if (res >= 0) {
            return res;
        }

        return val;
    }

    int lower(int v) {
        if (empty) {
            return -1;
        }


        if (v < val) {
            int res = -1;

            if (left != null) {
                res = left.lower(v);
            }
            if (res < 0) {
                return val;
            } else {
                return res;
            }
        }

        if (v == val) {
            return val;
        }

        if (right != null) {
            return right.lower(v);
        }

        return -1;
    }
    
    int upper(int v) {
        if (empty) {
            return -1;
        }


        if (v > val) {
            int res = -1;

            if (right != null) {
                res = right.upper(v);
            }
            if (res < 0) {
                return val;
            } else {
                return res;
            }
        }

        if (v == val) {
            return val;
        }

        if (left != null) {
            return left.upper(v);
        }

        return -1;
    }
}
